#ifndef CLASS_KNN
#define CLASS_KNN

#ifdef __cplusplus
#include <cv.h>
#include <ml.h>
#endif

#ifdef __cplusplus
extern "C" {
#else
    typedef struct CvKNearest CvKNearest;
#endif
    extern CvKNearest *treina_classificador (char *caminho_do_arquivo);
    extern int classifica(CvKNearest *classificador, float *caracteristicas, int n);

    void pre_processa_imagem_para_classificacao(IplImage *in, IplImage *out, int block_size, int delta);
    void extrai_caracteristicas(IplImage *contraste, IplImage *img, CvRect *r, float *caracteristicas);
    float dp_regiao(CvRect *r, IplImage *contrast_map, float media);
    float media_regiao(CvRect *r, IplImage *contrast_map);
    float preenchimento_regiao(CvRect *r, IplImage *recorte);
#ifdef __cplusplus
}
#endif

#endif
